package meerkat;

import meerkat.bulletinboard.BulletinBoardClient;

/**
 * Created by Vladimir Eliezer Tokarev  on 2/19/2016.
 * Handles the the after post state of VoterRegistry methods (that uses bulletinBoardClient to communicate with the server)
 */
public class BooleanHandler implements BulletinBoardClient.ClientCallback {
    public VoterRegistry.RegistryCallBack callback;

    /**
     * Init BooleanHandler
     * @param callback  voter registry callback object
     */
    public BooleanHandler(VoterRegistry.RegistryCallBack callback) {
        this.callback = callback;
    }

    /**
     * Calls the callback HandleResult method with passed object from bulletinBoardClient
     * @param msg the message that the bulletinBoardClient passes to the callback
     */
    @Override
    public void handleCallback(Object msg) {
        callback.HandleResult(msg);
    }

    /**
     * Calls the callback HandleResult method with false because the post method failed
     * @param t the exception data that have been thrown during the failure of the post method
     */
    @Override
    public void handleFailure(Throwable t) {
        callback.HandleResult(false);
    }
}
